unix  : OBJECTS_DIR = build/.o/unix
win32 : OBJECTS_DIR = build/.o/win32
mac   : OBJECTS_DIR = build/.o/mac

UI_DIR  = build/.ui
MOC_DIR = build/.moc
RCC_DIR = build/.rcc
DESTDIR = build/bin

win32 : DEFINES += _TTY_WIN_ QWT_DLL QT_DLL
unix  : DEFINES += _TTY_POSIX_

QT *= gui core

SOURCES = SerialPort/qextserialbase.cpp \
	  SerialPort/qextserialport.cpp \
	  SerialPort/ManageSerialPort.cpp \
	  Forms/mktool.cpp \
	  Forms/dlg_Config.cpp \
	  Forms/dlg_Motortest.cpp \
	  Forms/dlg_Preferences.cpp \
	  main.cpp \
	  cSettings.cpp \
	  ToolBox.cpp \
	  Forms/wdg_Settings.cpp

win32 : SOURCES += SerialPort/win_qextserialport.cpp
unix  : SOURCES += SerialPort/posix_qextserialport.cpp

HEADERS = SerialPort/qextserialbase.h \
	  SerialPort/qextserialport.h \
	  SerialPort/ManageSerialPort.h \
	  Forms/mktool.h \
	  Forms/dlg_Config.h \
	  Forms/dlg_Motortest.h \
	  Forms/dlg_Preferences.h \
	  global.h \
	  cSettings.h \
	  Parameter_Positions.h \
	  ToolBox.h \
    Forms/wdg_Settings.h

win32 : HEADERS += SerialPort/win_qextserialport.h
unix  : HEADERS += SerialPort/posix_qextserialport.h

FORMS += Forms/mktool.ui \
	 Forms/dlg_Config.ui \
	 Forms/dlg_Preferences.ui \
	 Forms/dlg_Motortest.ui \
    Forms/wdg_Settings.ui

unix {
	LIBS += -lqwt-qt4
	INCLUDEPATH += $(HOME)/include /usr/include/qwt-qt4
}

TEMPLATE = app

CONFIG += warn_on thread qt

TARGET = QMK-Groundstation

RESOURCES += MKTool.qrc
